# Don't set prefix, umake does.
PACKAGE_BRAND = gostai
URBI_ENV = remote
URBI_HOST = mipsel-linux
branddir = ${prefix}/${PACKAGE_BRAND}
hostdir = ${branddir}/core/${URBI_HOST}
envdir = ${branddir}/core/${URBI_HOST}/$(URBI_ENV)

# The basename (no extension) of the library we should link against.
# This default value is for backward compatibility: find the
# (hopefully) unique lib here.
LIBNAME = *
PTHREAD_CFLAGS = -pthread
PTHREAD_LIBS = 

# CPP.
CPP = mipsel-linux-uclibc-gcc -E
URBI_KERNEL_PATH = @URBI_KERNEL_PATH@
# Upper case.
URBI_ENV_CPPFLAGS = -DURBI_ENV_$$(echo $(URBI_ENV) | tr 'a-z' 'A-Z')
CPPFLAGS = -I/home/agb/openwrt/brcm-2.4/staging_dir/mipsel/usr/include -I/home/agb/openwrt/brcm-2.4/staging_dir/mipsel/include  -I$(prefix)/include/urbi -I$(prefix)/include \
           -I$(URBI_KERNEL_PATH)/gostai/kernel/include $(URBI_ENV_CPPFLAGS)   
ALL_CPPFLAGS = $(PRE_CPPFLAGS) $(CPPFLAGS) $(EXTRA_CPPFLAGS)

# C.
CC = mipsel-linux-uclibc-gcc
CFLAGS = $(PTHREAD_CFLAGS) -Os -pipe -mips32 -mtune=mips32 -funit-at-a-time -fhonour-copts 

# C++.
WARNING_CXXFLAGS =  -Wno-deprecated -Wall -W -Woverloaded-virtual -Wformat
CXXFLAGS = $(WARNING_CXXFLAGS) $(PTHREAD_CFLAGS) -Os -pipe -mips32 -mtune=mips32 -funit-at-a-time -fhonour-copts  -fno-rtti -pipe 
CXX = g++-uc

# Ld.
LD = mipsel-linux-uclibc-gcc
LDFLAGS = $(PTHREAD_LIBS) -L/home/agb/openwrt/brcm-2.4/staging_dir/toolchain-mipsel_gcc3.4.6/lib -L/home/agb/openwrt/brcm-2.4/staging_dir/mipsel/usr/lib -L/home/agb/openwrt/brcm-2.4/staging_dir/mipsel/lib 


# Libtool.
LIBTOOL = $(hostdir)/libtool
HOBJECTS = $(OBJECTS:.o=.$(URBI_HOST).o)
LTOBJECTS = $(HOBJECTS:.o=.lo)
OUTBIN = nothing
OUTLIB = nothing2

# Commands to compile and link.  Inspired from Automake's.
COMPILE = $(CC) $(ALL_CPPFLAGS) $(CFLAGS)
LTCOMPILE = $(LIBTOOL) --tag=C --mode=compile $(COMPILE)
CXXCOMPILE = $(CXX) $(ALL_CPPFLAGS) $(CXXFLAGS)
LTCXXCOMPILE = $(LIBTOOL) --tag=CXX --mode=compile $(CXXCOMPILE)
CXXLINK = $(LIBTOOL) --tag=CXX --mode=link \
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(EXTRALDFLAGS) -o $@


%.$(URBI_HOST).lo: %.c $(HEADERS) 
	$(LTCOMPILE) -c -o $@ $< 

%.$(URBI_HOST).lo: %.cc $(HEADERS)
	$(LTCXXCOMPILE) -c -o $@ $<

%.$(URBI_HOST).lo: %.cpp $(HEADERS)
	$(LTCXXCOMPILE) -c -o $@ $<

# UObject target.
$(OUTLIB): $(LTOBJECTS) $(LIBS)
	$(CXXLINK) $(LTOBJECTS) $(LIBS)

$(OUTBIN): $(LTOBJECTS) $(LIBS) 
	$(CXXLINK) $(LTOBJECTS) $(LIBS) $(envdir)/$(LIBNAME).la

# Override default targets to add headers dependency.
.SUFFIXES: .c .cc .cpp .$(URBI_HOST).o

.c.$(URBI_HOST).o: $(HEADERS) 
	$(COMPILE) -c -o $@ $<

.cc.$(URBI_HOST).o: $(HEADERS) 
	$(CXXCOMPILE) -c -o $@ $<

.cpp.$(URBI_HOST).o: $(HEADERS) 
	$(CXXCOMPILE) -c -o $@ $<

clean:
	$(RM) *.lo *.o
